/*
   See the "Notes" section of the following page.
   http://en.cppreference.com/w/c/io/setvbuf
*/
#include <stdio.h>

int main()
{
   char buf1[7];
   char buf2[7];

   setvbuf (stdout, buf1, _IOLBF, 7);  // line buffering
   setvbuf (stderr, buf2, _IOLBF, 7);  // line buffering

   fprintf(stdout, "1234567890\n");
   fprintf(stderr, "why?");
   //fflush(stderr);  // uncomment these two lines and
   //fflush(stdout);  // then try reversing their order

   return 0;
}
