/*

*/
#include <stdio.h>
#include <pthread.h>
#include <sched.h>   // for sched_yield()
#include <windows.h> // for Sleep()

pthread_mutex_t print_mutex = PTHREAD_MUTEX_INITIALIZER;

int main()
{
   setvbuf (stdout, NULL, _IOFBF, 16); // set a buffer size
   setvbuf (stderr, NULL, _IOFBF, 16); // set a buffer size

   //thread function prototypes
   void *thread1(void *vargp);
   void *thread2(void *vargp);

   pthread_t tid[2];

   //setbuf(stdout, NULL);

   // create threads
   //printf("Starting threads\n");
   pthread_create(&(tid[0]), NULL, thread1, NULL);
   pthread_create(&(tid[1]), NULL, thread2, NULL);

   // wait for the threads to finish
   pthread_join(tid[0], NULL);
   pthread_join(tid[1], NULL);

   return 0;
}


void *thread1(void *vargp)
{
   int i;
   for (i = 0; i < 100; i++)
   {
      pthread_mutex_lock(&print_mutex);
      fprintf(stdout, "abcdefghijklmnopqrstuvwxyz_");
      //fflush(stdout);
      pthread_mutex_unlock(&print_mutex);
      Sleep(1);
      //sched_yield();
      //pthread_yield();
   }
   return NULL;
}


void *thread2(void *vargp)
{
   int i;
   for (i = 0; i < 100; i++)
   {
      pthread_mutex_lock(&print_mutex);
      fprintf(stderr, "ABCDEFGHIJKLMNOPQRSTUVWXYZ_");
      //fflush(stderr);
      pthread_mutex_unlock(&print_mutex);
      Sleep(1);
      //sched_yield();
      //pthread_yield();
   }
   return NULL;
}
